Skip to main content

List of Tools

GET 

/sql/v1/organizations/:organization_id/environments/:environment_id/databases/:database_name/tools

Preview

Retrieve a sorted, filtered, paginated list of all Tools.

Request

Responses

Tools.

Response Headers
    X-Request-Id

    The unique identifier for the API request.

OpenAPI definition (YAML)
paths:
  /sql/v1/organizations/{organization_id}/environments/{environment_id}/databases/{database_name}/tools:
    get:
      x-lifecycle-stage: Preview
      x-self-access: true
      x-request-access-name: SQL API v1
      operationId: listSqlv1Tools
      description: '[![Preview](https://img.shields.io/badge/Lifecycle%20Stage-Preview-%2300afba)](#section/Versioning/API-Lifecycle-Policy)


        Retrieve a sorted, filtered, paginated list of all Tools.'
      parameters:
      - in: path
        name: organization_id
        required: true
        schema:
          type: string
          format: uuid
        description: The unique identifier for the organization.
      - in: path
        name: environment_id
        required: true
        schema:
          type: string
        description: The unique identifier for the environment.
      - in: path
        name: database_name
        required: true
        schema:
          type: string
        description: The name of the database.
      - name: page_size
        in: query
        required: false
        schema:
          type: integer
          default: 10
          maximum: 100
          x-max-page-items: 500
        description: A pagination size for collection requests.
      - name: page_token
        in: query
        required: false
        schema:
          type: string
          maxLength: 255
        description: An opaque pagination token for collection requests.
      tags:
      - Tools (sql/v1)
      security:
      - resource-api-key: []
      - global-api-key: []
      responses:
        '200':
          description: Tools.
          content:
            application/json:
              schema:
                type: object
                description: '`Tool` models a reusable tool resource backed by a connection that can be
                  referenced

                  by agents to perform actions.

                  The API allows you to create your tools.

                  ## The Tool Model

                  <SchemaDefinition schemaRef="#/components/schemas/sql.v1.Tool" />'
                required:
                - api_version
                - kind
                - metadata
                - data
                properties:
                  api_version:
                    type: string
                    enum:
                    - sql/v1
                    description: APIVersion defines the schema version of this representation of a resource.
                    example: sql/v1
                  kind:
                    type: string
                    description: Kind defines the object this REST resource represents.
                    enum:
                    - ToolList
                  metadata:
                    allOf:
                    - type: object
                      description: ListMeta describes metadata that resource collections may have
                      properties:
                        first:
                          description: A link to the first page of results. If a response does not contain
                            a first link, then direct navigation to the first page is not supported.
                          type: string
                          format: uri
                          nullable: true
                          example: https://api.confluent.cloud/v2/resourcekinds
                        last:
                          description: A link to the last page of results. If a response does not contain
                            a last link, then direct navigation to the last page is not supported.
                          type: string
                          format: uri
                          nullable: true
                          example: https://api.confluent.cloud/v2/resourcekinds?page_token=bcAOehAY8F16YD84Z1wT
                        prev:
                          description: A link to the previous page of results. If a response does not
                            contain a prev link, then either there is no previous data or backwards traversal
                            through the result set is not supported.
                          type: string
                          format: uri
                          nullable: true
                          example: https://api.confluent.cloud/v2/resourcekinds?page_token=YIXRY97wWYmwzrax4dld
                        next:
                          description: A link to the next page of results. If a response does not contain
                            a next link, then there is no more data available.
                          type: string
                          format: uri
                          nullable: true
                          example: https://api.confluent.cloud/v2/resourcekinds?page_token=UvmDWOB1iwfAIBPj6EYb
                        total_size:
                          description: Number of records in the full result set. This response may be
                            paginated and have a smaller number of records.
                          type: integer
                          format: int32
                          minimum: 0
                          example: 123
                      title: ListMeta
                    - properties:
                        self:
                          example: https://flink.us-west1.aws.confluent.cloud/sql/v1/organizations/org-abc/environments/env-123/databases/my-database/tools
                        first:
                          example: https://flink.us-west1.aws.confluent.cloud/sql/v1/organizations/org-abc/environments/env-123/databases/my-database/tools
                        last:
                          example: ''
                        prev:
                          example: ''
                        next:
                          example: https://flink.us-west1.aws.confluent.cloud/sql/v1/organizations/org-abc/environments/env-123/databases/my-database/tools?page_token=UvmDWOB1iwfAIBPj6EYb
                  data:
                    type: array
                    description: A data property that contains an array of resource items. Each entry
                      in the array is a separate resource.
                    items:
                      allOf:
                      - type: object
                        description: '`Tool` models a reusable tool resource backed by a connection that
                          can be referenced

                          by agents to perform actions.

                          The API allows you to create your tools.

                          ## The Tools Model

                          <SchemaDefinition schemaRef="#/components/schemas/sql.v1.Tool" />'
                        properties:
                          api_version:
                            type: string
                            enum:
                            - sql/v1
                            description: APIVersion defines the schema version of this representation
                              of a resource.
                            example: sql/v1
                            readOnly: true
                          kind:
                            type: string
                            description: Kind defines the object this REST resource represents.
                            enum:
                            - Tool
                            readOnly: true
                          metadata:
                            allOf:
                            - description: ObjectMeta is metadata that all persisted resources must have,
                                which includes all objects users must create.
                              required:
                              - self
                              properties:
                                self:
                                  description: Self is a Uniform Resource Locator (URL) at which an object
                                    can be addressed. This URL encodes the service location, API version,
                                    and other particulars necessary to locate the resource at a point
                                    in time
                                  type: string
                                  format: uri
                                  readOnly: true
                                  example: https://api.confluent.cloud/v2/kafka-clusters/lkc-f3a90de
                                resource_name:
                                  description: Resource Name is a Uniform Resource Identifier (URI) that
                                    is globally unique across space and time. It is represented as a Confluent
                                    Resource Name
                                  type: string
                                  format: uri
                                  readOnly: true
                                  example: crn://confluent.cloud/kafka=lkc-f3a90de
                                created_at:
                                  type: string
                                  format: date-time
                                  example: '2006-01-02T15:04:05-07:00'
                                  readOnly: true
                                  description: The date and time at which this object was created. It
                                    is represented in RFC3339 format and is in UTC.
                                updated_at:
                                  type: string
                                  format: date-time
                                  example: '2006-01-02T15:04:05-07:00'
                                  readOnly: true
                                  description: The date and time at which this object was last updated.
                                    It is represented in RFC3339 format and is in UTC.
                                deleted_at:
                                  type: string
                                  format: date-time
                                  example: '2006-01-02T15:04:05-07:00'
                                  readOnly: true
                                  description: The date and time at which this object was (or will be)
                                    deleted. It is represented in RFC3339 format and is in UTC.
                              readOnly: true
                              title: ObjectMeta
                            - properties:
                                self:
                                  example: https://flink.us-west1.aws.confluent.cloud/sql/v1/organizations/org-abc/environments/env-123/tools/linear-mcp-tool
                                uid:
                                  example: 12345678-1234-1234-1234-123456789012
                                resource_version:
                                  example: a23av
                                resource_name:
                                  example: ''
                          name:
                            type: string
                            example: linear-mcp-tool
                            description: The user provided name of the tool, unique within this environment.
                            pattern: '[a-z0-9_]([-a-z0-9_]*[a-z0-9_])?'
                            x-immutable: true
                            maxLength: 100
                          spec:
                            type: object
                            description: 'The spec of the Tool. A tool must reference either a `connection`
                              (for MCP or A2A tools)

                              or a `function` (for function-based tools), but not both.'
                            properties:
                              connection:
                                type: string
                                example: linear-mcp-connection-streamable
                                description: The name of the connection this tool uses. Required for MCP
                                  and A2A tools. Mutually exclusive with function.
                              function:
                                type: string
                                example: convert_to_celsius
                                description: The name of the function this tool wraps. Required for function-based
                                  tools. Mutually exclusive with connection.
                              comment:
                                type: string
                                description: An optional comment describing the tool.
                                maxLength: 4096
                              options:
                                type: object
                                description: 'A set of key-value option pairs that configure the tool''s
                                  behavior.

                                  Supported options vary by tool type:

                                  - MCP tools: type, allowed_tools, request_timeout, max_retries, headers

                                  - A2A tools: type, agent_card_path, request_timeout, max_retries

                                  - Function tools: type, description'
                                additionalProperties:
                                  type: string
                                example:
                                  type: mcp
                                  allowed_tools: create_issue, list_issues
                                  request_timeout: '30'
                            x-enable-listmeta: true
                            x-enable-objectmeta: true
                            title: sql.v1.ToolSpec
                          status:
                            type: object
                            required:
                            - phase
                            description: The status of the Tool
                            properties:
                              phase:
                                type: string
                                description: 'Describes the status of the tool:


                                  ACTIVE: The Tool is usable;


                                  INACTIVE: The Tool is not currently active;


                                  ERROR: The Tool encountered an error;

                                  '
                                example: ACTIVE
                                readOnly: true
                                enum:
                                - ACTIVE
                                - INACTIVE
                                - ERROR
                              detail:
                                type: string
                                description: Details about why the tool transitioned into a given status.
                                example: Tool is ready
                                readOnly: true
                            readOnly: true
                            title: sql.v1.ToolStatus
                        title: sql.v1.Tool
                      - type: object
                        required:
                        - api_version
                        - kind
                        - metadata
                        - name
                        - spec
                        - status
                        - organization_id
                        - environment_id
                    uniqueItems: true
                title: sql.v1.ToolList
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
        '400':
          description: Bad Request
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '400'
                  code: invalid_filter
                  title: Invalid Filter
                  detail: The 'delorean' resource can't be filtered by 'num_doors'
                  source:
                    parameter: num_doors
        '401':
          x-summary: Unauthorized
          description: The request lacks valid authentication credentials for this resource.
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            WWW-Authenticate:
              schema:
                type: string
              description: The unique identifier for the API request.
              example: Basic error="invalid_key", error_description="The API Key is invalid"
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '401'
                  code: user_unauthenticated
                  title: Authentication Required
                  detail: Valid authentication credentials must be provided
        '403':
          x-summary: Forbidden
          description: The access credentials were considered insufficient to grant access
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '403'
                  code: user_unauthorized
                  title: User Access Unauthorized
                  detail: The user 'mcfly' is not allowed to access the 'delorean' resource without the
                    'plutonium' role.
        '404':
          description: Not Found
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '404'
                  title: Not Found
        '429':
          description: Rate Limit Exceeded
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            X-RateLimit-Limit:
              schema:
                type: integer
              description: The maximum number of requests you're permitted to make per time period.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: The number of requests remaining in the current rate limit window.
            X-RateLimit-Reset:
              schema:
                type: integer
              description: "The relative time in seconds until the current rate-limit window resets. \
                \ \n  \n**Important:** This differs from Github and Twitter's same-named header which\
                \ uses UTC epoch seconds. We use relative time to avoid client/server time synchronization\
                \ issues."
            Retry-After:
              schema:
                type: integer
              description: The number of seconds to wait until the rate limit window resets. Only sent
                when the rate limit is reached.
        '500':
          description: Oops, something went wrong!
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '500'
                  code: out_of_gas
                  title: DeLorean Out Of Gas
                  detail: The DeLorean has run out of gas, but Doc Brown will fill 'er up for you asap
      servers:
      - url: https://flink.region.provider.confluent.cloud
        description: Flink Compute Pool Endpoint